from rest_framework import serializers
from .models import Booking, Event

class EventSerializer(serializers.ModelSerializer):
    class Meta:
        model = Event
        fields = [
            'id', 'organisation_type', 'pan_number', 'address', 'gstin_status', 
            'gst_number', 'email', 'bank', 'beneficiary_name', 'account_number', 
            'ifsc_code', 'title', 'overview', 'location', 'amount', 'total_tickets', 
            'event_category', 'event_date', 'event_time','thumbnail', 'created_by'
        ]

class BookingSerializer(serializers.ModelSerializer):
    class Meta:
        model = Booking
        fields = ['event', 'user', 'ticket_count', 'amount_paid', 'transaction_id', 'payment_status', 'booking_id', 'qr_code']

# class EventSerializer(serializers.ModelSerializer):
#     class Meta:
#         model = Event
#         fields = [
#             'id', 'title', 'overview', 'location', 'amount',
#             'total_tickets', 'available_tickets', 'event_date', 'event_time', 'status', 'thumbnail'
#         ]
    
class EventEditSerializer(serializers.ModelSerializer):
    class Meta:
        model = Event
        fields = ['thumbnail', 'available_tickets', 'overview']

    def validate_available_tickets(self, value):
        if value < 0:
            raise serializers.ValidationError("Available tickets cannot be negative.")
        return value